#!/bin/sh
# tbtorture - torture test using only commands readily available on
# most embedded distros (e.g. busybox-based commands)
#
# based on dohell by Ingo Molnar
#
# To use:
# run on target as root.  Because of NFS bug, do not have cwd in /tmp
# when you run it (or, change the script to put bigfile somewhere besides
# /tmp.)
#
# To stop the test, do 'rm /tbtorture_running'

run_file=/torture_running
echo 1 >$run_file

while [ -f $run_file ] ; do dd if=/dev/zero of=/tmp/bigfile bs=1024000 count=1024; done &
#while [ -f $run_file ] ; do dd if=/dev/zero of=/tmp2/bigfile bs=1024000 count=24; done &
#while [ -f $run_file ] ; do killall hackbench; sleep 10 ; done &
#while [ -f $run_file ] ; do /tmp/hackbench 20; done &
#ping -l 100000 -q -s 10 -f v &
# busybox ping doesn't have -l (preload) or -f (flood ping)
while [ -f $run_file ] ; do ping -q -s 10 192.168.2.1 -c 1 >/dev/null ; done &
while [ -f $run_file ] ; do du / >/dev/null ; done &

# some other things to try:
#while [ -f $run_file ] ; do ls -lRa / ; done &


# hang around while the run_file exists
echo "do 'rm $run_file' to stop torture test"
while [ -f $run_file ] ; do sleep 1 ; done 

### kill all my children
killall -9 dd
killall -9 du
killall -9 ping
sleep 5
killall -9 dd
killall -9 du
killall -9 ping

